<CsoundSynthesizer>
<CsOptions>
</CsOptions>
<CsInstruments>

/*
Example for MIDI keyboard, to show the use of presets.
Use MIDI key 72 to go to the next preset; 
use MIDI key 48 to go to the previous preset.
Use any other key to trigger instr cue1 in preset 1.
In preset 2, use a key below 60 to trigger cue2a,
or a key above 59 to trigger cue2b.
*/

sr = 44100
ksmps = 32
nchnls = 2
0dbfs = 1

          massign   0, "Midi" 
giSin     ftgen     0, 0, 1024, 10, 1 
giHann    ftgen     0, 0, 4096, 20, 2 
          seed      0 


  instr Master
;receive the value of the widget "cue"
gkCue      invalue    "cue"
  endin

  instr Midi

iNotNum    notnum
iVel       veloc

;;CUES FORWARD / REWIND
iCue       =          i(gkCue)
 if iNotNum == 72 then
           outvalue   "cue", iCue + 1
           igoto      end
 elseif iNotNum == 48 then
           outvalue   "cue", iCue - 1
           igoto      end
 endif

;;SINGLE PRESETS / CUES
 ;;CUE 1: general instrument call for all notes
  if iCue == 1 then 
           event_i    "i", "cue1", 0, 1, iNotNum, iVel
  
 ;;CUE 2: different instruments for each midi key
  elseif iCue == 2 then
    if iNotNum < 60 then
           event_i    "i", "cue2a", 0, 1, iNotNum, iVel
    else
           event_i    "i", "cue2b", 0, 1, iNotNum, iVel
    endif
  endif

end:       turnoff
  endin
  
  
  instr cue1
  ;e.g. mode
p3        =         10
iFq1      =         cpsmidinn(p4) 
iQ        random    50, 300
aImp      mpulse    p5*.2/127, p3
iFq2      =         iFq1 * 1.47
iFq3      =         iFq1 * 2.09
iFq4      =         iFq1 * 2.56
aMode1    mode      aImp, iFq1, iQ
aMode2    mode      aImp, iFq2, iQ
aMode3    mode      aImp, iFq3, iQ
aMode4    mode      aImp, iFq4, iQ
aMode     =         aMode1 + aMode2 + aMode3 + aMode4
          outs      aMode, aMode
  endin
  
  instr cue2a
  ;e.g. sample (different durations, volumes, skiptimes, speeds)
Sfile     =         "fox.wav"
iFilLen   filelen   Sfile
idur      random    .1, 1 
idb       random    -18, 0 
iskip     random    0, iFilLen-idur 
ispeed    random    -2, 2 
idir      random    -1, 1 
idir      =         (idir < 0 ? -1 : 1) 
ispeed    pow       2, ispeed 
aFox      diskin    Sfile, ispeed*idir, iskip, 1 
kenv      linseg    0, .01, ampdb(idb), p3-.02, ampdb(idb), .01, 0 
          outs      aFox*kenv 
  endin
  
  instr cue2b
  ;e.g. granular
p3        random    3, 10 
;ifreq   =         cpsmidinn(p4) 
ifreq     random    200, 400 
idens     random    10, 100 
iamp      =         1 / idens 
igraindur random    0.01, 0.3 
imgdur    =         .3 ;maximum grain dur 
aGrain    grain     iamp, ifreq, idens, iamp, 0, igraindur, giSin, giHann, imgdur, 1 
aGrain    linen     aGrain*p5*.01, p3/10, p3, p3/10 
          outs      aGrain, aGrain 
  endin
  
</CsInstruments>
<CsScore>
i "Master" 0 99999
</CsScore>
</CsoundSynthesizer>






<bsbPanel>
 <label>Widgets</label>
 <objectName/>
 <x>67</x>
 <y>30</y>
 <width>98</width>
 <height>28</height>
 <visible>true</visible>
 <uuid/>
 <bgcolor mode="nobackground">
  <r>231</r>
  <g>46</g>
  <b>255</b>
 </bgcolor>
 <bsbObject version="2" type="BSBSpinBox">
  <objectName>cue</objectName>
  <x>46</x>
  <y>62</y>
  <width>80</width>
  <height>25</height>
  <uuid>{d22a73cb-accc-42e8-a857-9d262eb0ce15}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <alignment>right</alignment>
  <font>Arial</font>
  <fontsize>20</fontsize>
  <color>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </color>
  <bgcolor mode="nobackground">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <resolution>1.00000000</resolution>
  <minimum>1</minimum>
  <maximum>1e+12</maximum>
  <randomizable group="0">false</randomizable>
  <value>2</value>
 </bsbObject>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>20</x>
  <y>27</y>
  <width>140</width>
  <height>32</height>
  <uuid>{31c8f51b-bb32-4645-a5aa-c8a4d6885ffa}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <label>Preset / Cue</label>
  <alignment>center</alignment>
  <font>Arial</font>
  <fontsize>20</fontsize>
  <precision>3</precision>
  <color>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </color>
  <bgcolor mode="nobackground">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
</bsbPanel>
<bsbPresets>
</bsbPresets>
